#!/usr/bin/python
import sys
import cv2.cv as cv
import os
from math import ceil, floor

from PIL import Image
from PuntosBiometricos import PuntosBiometricos

class Utilerias():

	def normaliza(self, n):
		if n - int(n) > 0.5:
			n = int(ceil(n))
		else:
			n = int(floor(n))
		return n

	def tomarFoto(self, path):
		nombre = path
		captura = cv.CreateCameraCapture(0) 
		cv.NamedWindow("result", 1)
		if captura:
			copia = None
			frame = cv.QueryFrame(captura)
			if not frame:
				cv.WaitKey(0)
			if not copia:
				copia = cv.CreateImage((frame.width,frame.height), cv.IPL_DEPTH_8U, frame.nChannels)
			if frame.origin == cv.IPL_ORIGIN_TL:
				cv.Copy(frame, copia)
			else:
				cv.Flip(frame, copia, 0)
			cv.SaveImage(nombre, copia)
			cv.WaitKey(10)
			print "Imagen Tomada"
		else:
			image = cv.LoadImage(input_name, 1)
			detect_and_draw(image, cascade)
			cv.WaitKey(0)
			cv.DestroyWindow("result")
		return nombre

	def buscarElemento(self, path_entrada,  cascada):
		cascada = cv.Load(self.obtenerPath(cascada))
		imagen = self.cargarImagenCV(path_entrada)
		objetos = cv.HaarDetectObjects(imagen, cascada, cv.CreateMemStorage())
		return objetos

	def cargarImagenCV(self, path_imagen):
		return cv.LoadImage(self.obtenerPath(path_imagen), 0)

	def cargarImagenPIL(self, path):
		return Image.open(path)

	def obtenerPath(self, nombre):
		path = os.path.dirname(os.path.realpath(__file__))
		path = os.path.join(path, nombre)
		return path

	def generarArchivosDeTrabajo(self, original, p, foto):
		if foto == 1:
			original = self.tomarFoto(original)
		ori = self.cargarImagenCV(original)
		pathEntrada = p.path_medidas
		pathSalida  = p.path_resultado

		cp1 = cv.CreateImage((ori.width,ori.height), cv.IPL_DEPTH_8U, ori.nChannels)
		cv.Copy(ori, cp1)
		cv.SaveImage(pathEntrada, cp1)

		im = self.cargarImagenCV(pathEntrada)

		copia = cv.CreateImage((im.width,im.height), cv.IPL_DEPTH_8U, im.nChannels)
		cv.Copy(im, copia)
		cv.SaveImage(pathSalida, copia)

		return original, pathEntrada, pathSalida

	def ordenaLista(self, lista, elementos):
		lista.sort(key=lambda x: x[1])
		if len(lista) > elementos:
			sobrante = len(lista) - elementos
			for i in range(sobrante):
				lista.pop(0)
		return lista

	def recortarRostro(self, path_imagen, lista):
		imagen = self.cargarImagenCV(path_imagen)
		for (x,y, ancho, alto),n in lista:
			cv.SetImageROI(imagen, (x, y, ancho, alto))
		cv.SaveImage(path_imagen, imagen)


	def buscarPuntosBiometricos(self, im, io, utils, prop):
		pb = PuntosBiometricos(prop, utils)
		puntos_rostro = utils.buscarElemento(im, prop.cascada_rostro)
		self.recortarRostro(im, puntos_rostro)
		self.recortarRostro(io, puntos_rostro)

		#PARA REDIMENSIONAR LA IMAGEN
		imed = self.cargarImagenCV(im)
		isal = self.cargarImagenCV(io)
		red_medidas = cv.CreateImage( ( prop.imagen_x, prop.imagen_y ), imed.depth, imed.nChannels)
		cv.Resize(imed, red_medidas, interpolation=cv.CV_INTER_CUBIC)
		cv.Resize(isal, red_medidas, interpolation=cv.CV_INTER_CUBIC)
		cv.SaveImage(im, red_medidas)
		cv.SaveImage(io, red_medidas)

		imx = self.cargarImagenCV(im)
		tam = cv.GetSize(imx)
		
		pb.mapa_rostro = puntos_rostro

		puntos_ojos = self.buscarElemento(im, prop.cascada_ojos)
		puntos_ojos = self.ordenaLista(puntos_ojos, 2)
		pb.mapa_ojos = puntos_ojos	

		puntos_nariz = self.buscarElemento(im, prop.cascada_nariz)
		puntos_nariz = self.ordenaLista(puntos_nariz, 1)
		pb.mapa_nariz = puntos_nariz

		puntos_boca = self.buscarElemento(im, prop.cascada_boca)
		puntos_boca = self.ordenaLista(puntos_boca, 1)
		pb.mapa_boca = puntos_boca

		return pb